/**
 * Klasse Circle71
 *
 * This is GPL'd code
 * (c) by Patrick KIlian 2003
 */ 
import java.math.*;
/**
 * Ein Kreis mit den Eigenschaften x-Koordinate des Mittelpunktes, 
 * y-Koordinate des Mittelpunktes und nicht negativer Radius, der das
 * Interface Figure71 implemtiert und dazu von Figure71Impl erbt.
 *
 * @author Patrick Kilian
 * @version 1.00
 */
public class Circle71 extends Figure71Impl {
    /**
     * x-Koordinate des Mittelpunktes
     */
    private double x = 0;
    /**
     * y-Koordinate des Mittelpunktes
     */
    private double y = 0;
    /**
     * nicht negativer Radius
     */
    private double r = 0;
    /**
     * Konstruktor der Klasse Circle71
     *
     * @param x x-Koordinate des Mittelpunktes
     * @param y y-Koordinate des Mittelpunktes
     * @param r nicht negtiver Radius
     */
    public Circle71 (double x, double y, double r) {
        this.x = x;
        this.y = y;
        if (r >= 0) {
            this.r = r;
        }
    }
    /**
     * Gibt die Flche des Kreises zurck
     *
     * @return Die Kreisflche als Double-Zahl
     */
    public double area() {
        return(Math.PI * r * r);
    }
    /**
     * Gibt den Umfanf ges Kreises zurck
     *
     * @return Den Kreisumfang als Double-Zahl
     */
    public double circumference() {
        return(2 * Math.PI * r);
    }
    /**
     * Testet ob der Punkt mit den Koordinaten (x|y) im Kreis liegt
     * 
     * @param x x-Koordinate
     * @param y y-Koordinate
     * @return true, wenn der Punkt im Kreis leigt, ansonst false
     */
    public boolean overlaps(double x, double y) {
        if ( (x - this.x)*(x - this.x) + (y - this.y)*(y - this.y) > r * r) {
            return(false);
        } else {
            return(true);
        }
    }
    /**
     * Gibt eine textuelle Beschreibung der Kreises zurck
     *
     * @return String der den Kreis beschreibt
     */
    public String toString() {
        return(new String("Circle(" + x + "," + y + "," + r + ")"));
    }
    /**
     * Gibt die Rot-Komponente der Farbe des Kreisrandes zurck
     *
     * @return Den Rotwert der Randfarbe
     */
    public int getBorderColorRed() {
        return((int) (getColorRed() / 2));
    }
    /**
     * Gibt die Grn-Komponente der Farbe des Kreisrandes zurck
     *
     * @return Den Grnwert der Randfarbe
     */
    public int getBorderColorGreen() {
        return((int) (getColorGreen() / 2));
    }
    /**
     * Gibt die Blau-Komponente der Farbe des Kreisrandes zurck
     *
     * @return Den Blauwert der Randfarbe
     */
    public int getBorderColorBlue() {
        return((int) (getColorBlue() / 2));
    }
}
