/**
 * Klasse Figure71Component
 *
 * This is GPL'd code
 * (c) by Patrick Kilian 2003
 *
 * Verwaltet ein Array von Figure71-Objecten, implementiert aber selbst das
 * Interface Figure71
 *
 * @author Patrick Kilian
 * @version 1.00
 */
public class Figure71Component extends Figure71Impl {
    /**
     * Last-Pointer
     */
    private int last;
    /**
     * Gre des Arrays
     */
    private int count;
    /**
     * Das Array selbst:
     */
    private Figure71[] figures;
    /**
     * default-Konstruktor erzeugt eine Array fr bis zu 10 Objecte
     */
    public Figure71Component() {
        count = 10;
        last = -1;
        figures = new Figure71[10];
    }
    /**
     * Gibt eine testuelle Beschreibung der Figure zurck
     * 
     * @return Beschreibung der Figure als String
     */
    public String toString() {
        return(new String());
    }
    /**
     * Konstruktor fr beliebige Arraygren
     *
     * @param maxSize die maximal mgliche Anzahl an Elementen
     */
    public Figure71Component(int maxSize) {
        if (maxSize > 0) {
            count = maxSize;
            last = -1;
            figures = new Figure71[maxSize];
        } else {
            System.out.println("Ungltige Anzahl: " + maxSize);
        }
    }
    /**
     * Fgt eine Figure ans Ende des Array an, falls das Array noch nicht
     * voll ist.
     *
     * @param f Ein Object des Figure71 Typs
     */
    public void addFigure(Figure71 f) {
        if (last < count - 1) {
            last++;
            figures[last] = f;
        } else {
            System.out.println("Tut mir leid, das Array ist voll.");
        }
    }
    /**
     * Gibt das Pbject an der Stell "pos" zurck
     *
     * @param pos Das wievielte Object soll ausgegeben werden
     * @return das zugehrige Figure71-Objekt
     */
    public Figure71 getFigure(int pos) {
        return(figures[pos]);
    }
    /**
     * Gibt die Gesamtflche als Summe aller Teilflchen aus nimmt also keine
     * Rcksicht auf berlapung
     * @return die Summe aller Einzelflchen
     */
    public double area() {
        double area = 0;
        for(int i = 0; i <= last; i++) {
            area += figures[i].area();
        }
        return(area);
    }
    /**
     * Gibt einen Gesamtumfang als Summe Summe aller Umfnge aus und nimmt
     * dabei keine Rcksicht auf berlappung
     *
     * @return die Summe aller Umfnge
     */
    public double circumference() {
        double circumference = 0;
        for(int i = 0; i <= last; i++) {
            circumference += figures[i].circumference();
        }
        return(circumference);
    }
    /**
     * Testet die berdeckung aller Figuren mit dem Punkt (x|y)
     *
     * @param x x-Koordinate
     * @param y y-Koordinate
     * @return true wenn mindestens eine Flche mit dem Ounkt berlappt
     */
    public boolean overlaps(double x, double y) {
        boolean overlap = false;
        for(int i = 0; i <= last; i++) {
            if (figures[i].overlaps(x, y) == true) {
                overlap = true;
            }
        }
        return(overlap);
    }
    /**
     * Dummy-Deklaration
     *
     * @param a wird ignoriert
     * @param b wird ignoriert
     * @param c wird ignoriert
     */
    public void setColor(int a, int b, int c) {
    }
    /**
     * Gibt Null statt dem roten Farbanteil aus
     *
     * @return unspezifiert, daher 0
     */
    public int getColorRed() {
        return(0);
    } 
    /**
     * Gibt Null statt dem grnen Farbanteil aus
     *
     * @return unspezifiert, daher 0
     */
    public int getColorGreen() {
        return(0);
    } 
    /**
     * Gibt Null statt dem blauen Farbanteil aus
     *
     * @return unspezifiert, daher 0
     */
    public int getColorBlue() {
        return(0);
    } 
}
