/**
 * Figure71Impl
 *
 * This is GPL'd code
 * (c) Patrick Kilian 2003
 *
 * abstracte Klasse, die das Interface Figure71 implementiert
 * @author Patrick Kilian
 * @version 1.00
 */
public abstract class Figure71Impl implements Figure71 {
    /**
     * Roter Farbanteil
     */
    private int colorRed = 0;
    /**
     * Grner Farbanteil
     */
    private int colorGreen = 0;
    /**
     * Blauer Farbeanteil
     */
    private int colorBlue = 0;
    /**
     * leerer Default-Konstruktor
     */
    public Figure71Impl() {
    }
    /**
     * Gibt den roten Farbanteil zurck
     *
     * @return Rotfarbteil als Integer-Zahl
     */
    public int getColorRed() {
        return(colorRed);
    }
    /**
     * Gibt den grnen Farbanteil zurck
     *
     * @return Grnfarbteil als Integer-Zahl
     */
    public int getColorGreen() {
        return(colorGreen);
    }
    /**
     * Gibt den blauen Farbanteil zurck
     *
     * @return Blaufarbteil als Integer-Zahl
     */
    public int getColorBlue() {
        return(colorBlue);
    }
    /**
     * Setzt die Farbe auf den als RGB-Farbe angegebenen Wert
     *
     * @param red roter Farbteil (0-255)
     * @param green grner Farbteil (0-255)
     * @param blue blauer Farbteil (0-255)
     */
    public void setColor(int red, int green, int blue) {
        if (0 <= red && red <= 255) {
            colorRed = red;
        }
        if (0<= green && green <= 255) {
            colorGreen = green;
        }
        if (0 <= blue && blue <= 255) {
            colorBlue = blue;
        }
    }
    /**
     * Berechnet die Flche der geometrischen Figur
     *
     * @return Die Flche der Figur
     */
    public abstract double area();
    /**
     * Berechnet dem Umfang der Figur, d.h. die Lnge der "Auenkanten".
     *
     * @return der Umfang der Figur.
     */
    public abstract double circumference();
    /**
     * Berechnet, ob die Figure den Punkt mit den angegbenen Koordinaten
     * berdeckt.
     *
     * @param x Die x-Koordinate des zu berprfenden Punktes
     * @param y Die y-Koordinate des zu berprfenden Punktes
     *
     * @return true wenn die Figur den Punkt berdeckt,
     *         false sonst.
     */
    public abstract boolean overlaps(double x, double y);
    /**
     * Liefert einen, die Figur beschreibenden String, mit dem Namen der Figur
     * und den wichtigsten Attributen.
     *
     * @return Eine textuelle Beschreibung der Figur.
     */
    public abstract String toString();
    // public static void main(String[] args) {
    // }
}    
