/**
 * Klasse Rectangle
 *
 * This id GPL'd code
 * (c) by Patrick Kilian 2003
 */
import java.math.*;
/**
 * Ein achsenparalleles Rechteck mit linker und recher x-Koordinate und
 * oberer und unterer y-Koordinate das dasd Interface Figure71 implementiert
 * und dazu von Figure71Impl erbt.
 *
 * @author Patrick Kilian
 * @version 1.00
 */
public class Rectangle71 extends Figure71Impl {
    /**
     * linker Rand
     */
    private double x1 = 0;
    /**
     * rechter Rand
     */
    private double x2 = 0;
    /**
     * Unterkante
     */
    private double y1 = 0;
    /**
     * Oberkante
     */
    private double y2 = 0;
    /**
     * Erzeugt ein neues Rechteck mit den angebenen Werte und sorgt fr
     * die richtige Sortierung der Koordinaten 
     *
     * @param x linker Rand
     * @param y unterer Rand
     * @param width Breite
     * @param height Hhe
     */
    public Rectangle71(double x, double y, double width, double height) {
        x1 = x;
        y1 = y;
        x2 = x + width;
        y2 = y + height;
        double temp;
        if (x2 <= x1) {
            temp = x2;
            x2 = x1;
            x1 = temp;
        }
        if (y2 <= y1) {
            temp = y1;
            y2 = y1;
            y1 = temp;
        }
    }
    /**
     * Gibt die Flche des Rechtecks aus
     *
     * @return Die Flche als double-Zahl
     */
    public double area() {
        return((x2 - x1) * (y2 - y1));
    }
    /**
     * Gibt den Umfang aus
     * 
     * @return Den Umfang als Double-Zahl
     */
    public double circumference() {
        return(2 * ( (x2 - x1) + (y2 - y1) ) );
    }
    /**
     * Testet ob der Punkt mit den Koordinaten (x|y) im Rechteck liegt
     *
     * @param x x-Koordinate
     * @param y y-Koordinate
     * @return true, wenn der POunkt im Rechteck liegt anaonsten false
     */
    public boolean overlaps(double x, double y) {
        if ( ((x1 <= x) && (x <= x2)) && ((y1 <= y) && (y <= y2)) ) {
            return(true);
        } else {
            return(false);
        }
    }
    /**
     * Gibt die textuelle Beschreibung des Rechtecks aus
     *
     * @return Die Beschriebung als String
     */
    public String toString() {
        return(new String("Rectangle("+x1+","+y1+","+x2+","+ y2+")"));
    }
}
